<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once JPATH_LIBRARIES . '/joomla/database/table/content.php';
require_once JPATH_LIBRARIES . '/joomla/database/table/category.php';

jimport('joomla.form.fields.category');


function fix_content($id, &$aliases){
    $tbl = new JTableContent(JFactory::getDBO());
    $tbl->load($id);
    $alias_reset = false;
    while(in_array($tbl->alias, $aliases)){
        if(preg_match('/.*?-\d+$/', $tbl->alias)){
            $index = (int) preg_replace('/.*?-(\d+)$/', '\1', $tbl->alias);
            //vardie($index);
            $tbl->alias = preg_replace('/-\d+$/', '-' . ($index+1), $tbl->alias);
        } else {
            $tbl->alias = $tbl->alias . '-1';
        }
        $alias_reset = true;
    }
    $tbl->setRules(new JRules(array()));
    $ret = $tbl->store();
    if($ret) {
        echo "<div>Fixed permissions for article #$id {$tbl->title}</div>";
        $aliases[] = $tbl->alias;
    } else {
        echo "<div  style=\"color:red\">Failed fixing permissions for article #$id {$tbl->title}</div>";
    }
    if($alias_reset){
        echo "<div style=\"color:blue; font-size:8px;\"> -- Warning: alias reset to {$tbl->alias}</div>";
    }
}




$id = JRequest::getInt('id', -1);



$cat_tbl = new JTableCategory(JFactory::getDBO());
$con_tbl = new JTableCategory(JFactory::getDBO());


$cat_tbl->rebuild();



if($id < 0){
    $uri = JURI::current();
    $db = JFactory::getDBO();
    $query  = $db->getQuery(true);
    $query->select('*');
    $query->from('#__categories');
    $query->where('extension = "com_content" and level = 1');
    $db->setQuery($query);
    $options = '';
    foreach($db->loadObjectList() as $k => $v){
        foreach($cat_tbl->getTree($v->id) as $kk => $vv){
            $prefix = str_repeat("--", $vv->level - 1);
            $options .= "<option value=\"{$vv->id}\">$prefix {$vv->title}</option>";
        }
    }
    echo <<<__HTML__

<h2>For more informations, please visit the component's <a href="http://www.itopen.it/?p=663">home page</a></h2>

<h1 style="color:red">Warning: you should make a database backup before running this component (there aren't any known problems but you don't want to be the first, right?).</h1>
<h2>Choose the category from the list below to process the a single category and its children or choose "Process all" to process the whole category tree.</h2>
<form method="get" action="$uri">
    <p>
    <label for="id">Choose the category to process<label><br />
    <select name="id" id="id">
        <option value="0">** Process all **</option>
        $options
    </select>
    </p>
    <p>
    <label for="fix_cattree">Fix wrong category tree values<label><br />
    <input type="checkbox" name="fix_cattree" id="fix_cattree" />
    </p>
    <p><input type="submit" /></p>
    <input type="hidden" id="option" name="option" value="com_fixperm" />
</form>
__HTML__;

    return;
} else {
    $id = (int) $id;
}



// Fix wrong tree
if(JRequest::getVar('fix_cattree', false)) {
    $db = JFactory::getDBO();
    $query = "select max(rgt)+1 from #__categories where title != 'ROOT'";
    $db->setQuery($query);
    $result = $db->loadResult();
    # usare il valore di cui sopra
    $query = "update #__categories set rgt = $result where title = 'ROOT'";
    $db->setQuery($query);
    $db->query();

    $query = "update #__categories set parent_id = 1 where parent_id = 0 and title != 'ROOT'";
    $db->setQuery($query);
    $db->query();

    # toglie -2 dalla pubblicazione
    $query = "update #__categories set published = 1 where published = -2";
    $db->setQuery($query);
    $db->query();
}




if($id){
    $tree = $cat_tbl->getTree($id);
} else {
    $tree = array();
    // Get articles
    $query  = JFactory::getDBO()->getQuery(true);
    $query->select('*');
    $query->from('#__categories');
    $query->where('extension = "com_content"');
    JFactory::getDBO()->setQuery($query);
    $tree = JFactory::getDBO()->loadObjectList();
}


foreach($tree as $k => $v){
    $cat_tbl->load($v->id);
    $cat_tbl->setRules(new JRules(array()));
    $ret = $cat_tbl->store();
    if($ret) {
        echo "<h3>Fixed permissions for category #{$v->id} {$cat_tbl->title}</h3>";
    } else {
        echo "<h3 style=\"color:red\">Failed fixing permissions for category #{$v->id} {$cat_tbl->title}</h3>";
    }

    // Get articles
    $query  = JFactory::getDBO()->getQuery(true);
    $query->select('id');
    $query->from('#__content');
    $query->where('catid = '.(int) $v->id);

    $aliases = array();
    JFactory::getDBO()->setQuery($query);
    if ($result = JFactory::getDBO()->loadResultArray()) {
        foreach($result as $kk => $vv){
            fix_content($vv, $aliases);
        }
    }
}

$cat_tbl->rebuild();

echo '<h2 styl="color:green">Everything done, if you\'ve found this program useful, please <a href="http://www.itopen.it/?p=663">say thanks!</a></h2>';


?>
